/*
-------------------------------------------------------------------
DSudoku 1.0: a WinS Sudoku game using Sudoku Sensei 1.03
Copyright (C) 2005 Patrick Huy

SUDOKU SENSEI 1.03
Copyright (C) 2005  Martin Knoblauch

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston,
MA  02110-1301, USA.

-------------------------------------------------------------------
*/
/*+----------------------------------------------+  
  | Created with:  WinDS Form Designer, a visual |  
  |  form designer for WinDS                     |  
  | (c) Francesco Lombardi 2005                  |  
  +----------------------------------------------+  
    Last version on: http://itaprogaming.free.fr    
    More infos:      http://www.gbawins.com         
  +----------------------------------------------+*/


#include "DSudoku.h"

DSudoku_Class::DSudoku_Class():
	CtlWindow(Bbox(44, 56, 169, 124), "DSudoku", 0)
{
	Sudoku = new CtlSudoku (Bbox(0,0,104,104));
	DSudokuNewGame = new CtlButton ( Bbox(106, 6, 57, 17), "New Game");
	
	DSudokuChooser = new CtlDropList (Bbox(107, 70, 49, 18));
	DSudokuChooser->AddItem(" ");
	DSudokuChooser->AddItem("1");
	DSudokuChooser->AddItem("2");
	DSudokuChooser->AddItem("3");
	DSudokuChooser->AddItem("4");
	DSudokuChooser->AddItem("5");
	DSudokuChooser->AddItem("6");
	DSudokuChooser->AddItem("7");
	DSudokuChooser->AddItem("8");
	DSudokuChooser->AddItem("9");
	DSudokuChooser->SetItem(0);
	
	DSudokuHelp = new CtlCheckBox ( Bbox(109, 50, 49, 17), false, "Help");
	DSudokuDone = new CtlLabel ( Bbox (110, 35, 60, 12), "Well Done");
	DSudokuDone->Hide();
	
	AddSubControl(Sudoku);
	AddSubControl(DSudokuChooser);
	AddSubControl(DSudokuHelp);
	AddSubControl(DSudokuNewGame);
	AddSubControl(DSudokuDone);
	Sudoku->Create();
	
	Sudoku->AutoResizeX (true);
	Sudoku->AutoResizeY (true);
	DSudokuNewGame->AnchorX (true);
	DSudokuChooser->AnchorX (true);
	DSudokuHelp->AnchorX (true);
	DSudokuDone->AnchorX (true);
}

void DSudoku_Class::HandleMessages()
{
	WS_MSG msg;
	FORALLMESSAGES(msg)
	{
		switch(msg.id)
		{
			case WS_MSG_DROPDOWNLISTCHOICE:
				if (msg.sender == this->DSudokuChooser)
					Sudoku->setFocusedTo (msg.data);
				break;
			case WS_MSG_BUTTONPRESSED:
				if (msg.sender == this->DSudokuNewGame) {
					DSudokuDone->Hide();
					Sudoku->Create();
				}
				break;
			case WS_MSG_CHECKBOXPRESSED:
				if (msg.sender == this->DSudokuHelp) {
					Sudoku->setHelp (this->DSudokuHelp->IsChecked());
				}
				break;
		}
		if (msg.id == Sudoku->WS_MSG_SUDOKU_FOCUS_CHANGED && msg.sender == this->Sudoku) {
			DSudokuChooser->SetItem (Sudoku->getFocusedValue());
			if (Sudoku->getFocusedChangeable()) DSudokuChooser->Enable();
			else DSudokuChooser->Disable();
		} else if (msg.id == Sudoku->WS_MSG_SUDOKU_CLEARED && msg.sender == this->Sudoku) {
			this->DSudokuDone->Unhide();
		}
	}
	CtlWindow::HandleMessages();
}

