/*
  --- !!! WARNING !!! ---
  This file comes directly from ndslib. I have only changed variable names in
  order to avoid linking conflicts with other applibs.
*/
/*+----------------------------------------------+
  | Cippotto: WinDS Chip8 Emulator               |
  | (c) Francesco Lombardi 2006                  |
  +----------------------------------------------+
    Created for WinDS 2006 Compo
    http://www.gbawins.com
    http://itaprogaming.free.fr
  +----------------------------------------------+*/

#include "key.h"
#include <nds.h>
unsigned short int keys     = 0;
unsigned short int keysold  = 0;

unsigned short int oldx     = 0;
unsigned short int oldy     = 0;

void c8KeyPadInit()
{
	keys    = 0;
	keysold = 0;
}

signed int absol(signed int val)
{
	if (val >= 0)
		return val;

	return (val * -1);
}

void c8ScanKeyPad()
{
	keysold = keys;
	keys    = KEYPAD_CUR;

	if(absol(IPC->touchXpx - oldx) > 20 || absol(IPC->touchYpx - oldy) > 20)
		keys &= ~KEYPAD_TOUCH;

	oldx = IPC->touchXpx;
	oldy = IPC->touchYpx;

}
unsigned int c8KeysPressed()
{
	return keys;
}

unsigned int c8keysDown()
{
	return (keys^keysold)&keys;
}

unsigned int c8keysUp()
{
	return (keys^keysold)&(~keys);
}

const char * c8GetKeyName(int value)
{
  switch (value) {
    case KEY_UP: return "Up"; break;
    case KEY_LEFT: return "Left"; break;
    case KEY_RIGHT: return "Right"; break;
    case KEY_DOWN: return "Down"; break;
    case KEY_A: return "A"; break;
    case KEY_B: return "B"; break;
    case KEY_X: return "X"; break;
    case KEY_Y: return "Y"; break;
    case KEY_L: return "T-Left"; break;
    case KEY_R: return "T-Right"; break;
    case KEY_SELECT: return "Select"; break;
    case KEY_START: return "Start"; break;
    default: return "";
  }
}