#include <winsapi.h>

#include "ctlbuttoncn.h"
#include "ctlconsolewindow.h"

#include "meds_icon_bin.h"

#ifndef __MEDS_H__
#define __MEDS_H__

#ifndef NULL
#define NULL        ((void *)(0))
#endif /* ! NULL */

#define MEDS_BUTTON_X   24
#define MEDS_BUTTON_Y   24

#define WINDOW_XR   (MEDS_BUTTON_X * 3)     /* Width  of the window */
#define WINDOW_YR   (MEDS_BUTTON_Y * 4)     /* Height of the window */
#define WINDOW_X    (WINDOW_XR + 5)
#define WINDOW_Y    (WINDOW_YR + 14 + 13 + 5)

/* MEDS Switches */
#define CASE_UPPER      0
#define CASE_LOWER      1
#define MODE_CHARS      0
#define MODE_NUMER      1

/* Our Window class */
class wMedsWindow : public CtlWindow
{
    private:
        CtlConsoleWindow *messageWindow;
        CtlButtonCn *gsButtons[12];
        
        int pressbutton;
        int releasebutton;
        
        int currentMode;
        int currentCase;
        
    public:
        wMedsWindow(Bbox b = Bbox(248 - WINDOW_X, 184 - WINDOW_Y, WINDOW_X, WINDOW_Y));
        ~wMedsWindow();
        
        void HandleMessages();
        
        int handleInput(int press, int release);
        void doMode();
        int getButtonSetNum();
};

#endif /* ! __MEDS_H__ */

/* EOF */
