#include <winsapi.h>

#include "ctlconsolewindow.h"

CtlConsoleWindow::CtlConsoleWindow(Bbox b):
    CtlWindow(b, "Console", "Status: Ready")
{
    // Remove the close button
    GetTitleBar()->RemoveSubControl(GetCloseButton()->GetID());
    
    textBox = new CtlTextBoxEx(Bbox(0, 0, GetClientArea().xdim, GetClientArea().ydim));
    textBox->AutoResizeX();
    textBox->AutoResizeY();
    
    AddSubControl(textBox);
};

CtlTextBoxEx::CtlTextBoxEx(Bbox b):
    Control(b)
{
    // DO NOTHING
};

void CtlTextBoxEx::HandleMessages()
{
    Control::HandleMessages();
};

void CtlConsoleWindow::HandleMessages()
{
    CtlWindow::HandleMessages();
};

void CtlTextBoxEx::_DrawForeground()
{
    StringEx str(text.c_str());
    str.Format(0, GetClientArea().xdim);
    
    FORMAT_DATA formatdata = str.GetFormatData();
    
    Bbox bounds = GetClientArea();
    
    int y = 0;
    
    bounds.x++;
    bounds.y++;
    
    bounds.xdim -= 2;
    bounds.ydim -= 2;
    
    for(int i = 0; i < ((int)formatdata.size()) - 1; i++)
    {
        Screen.DrawString(str.GetFont(), bounds.x, bounds.y + y,
            GetForeColor(), str.c_str(), formatdata[i], formatdata[i + 1]);
        
        y += str.GetFont().GetHeight() + 1;
        
        if(y >= bounds.ydim)
        {
            break;
        };
    };
};

void CtlConsoleWindow::write(string s)
{
    getTextBox()->text += s;
};

void CtlConsoleWindow::del(int num)
{
    int x = num;
    
    if((int)getTextBox()->text.length() < num)
    {
        x = getTextBox()->text.length();
    };
    
    getTextBox()->text.erase(getTextBox()->text.length() - x, x);
};

CtlTextBoxEx *CtlConsoleWindow::getTextBox()
{
    return(textBox);
};

/* EOF */
